## knot-resolver 3.2.1

=== Makefile ===
SHELL=/bin/bash -o pipefail -o errexit

include config.mk
include platform.mk

# Targets
all: info lib daemon client modules etc
install: lib-install daemon-install client-install modules-install etc-install
check: all tests
clean: contrib-clean lib-clean daemon-clean client-clean modules-clean \
	tests-clean doc-clean bench-clean coverage-clean
doc: doc-html
lint: lint-lua lint-c
lint-c: libkres-lint kresd-lint kresc-lint
lint-lua: $(patsubst %.lua.in,%.lua,$(wildcard */*/*.lua.in))
	luacheck --codes --formatter TAP .

.PHONY: all install check clean doc info lint

# Dependencies
KNOT_MINVER := 2.7.2
$(eval $(call find_lib,libknot,$(KNOT_MINVER),yes))
$(eval $(call find_lib,libdnssec,$(KNOT_MINVER),yes))
$(eval $(call find_lib,libzscanner,$(KNOT_MINVER),yes))
$(eval $(call find_lib,lmdb))
$(eval $(call find_lib,libuv,1.0,yes))
$(eval $(call find_lib,nettle,,yes))
$(eval $(call find_alt,lua,luajit))
$(eval $(call find_luapkg,ltn12))
$(eval $(call find_luapkg,ssl.https))
$(eval $(call find_lib,cmocka))
$(eval $(call find_bin,doxygen))
$(eval $(call find_bin,sphinx-build))
$(eval $(call find_pythonpkg,breathe))
$(eval $(call find_lib,socket_wrapper))
$(eval $(call find_lib,libsystemd,227))
$(eval $(call find_lib,gnutls))
$(eval $(call find_lib,libedit))
$(eval $(call find_lib,libprotobuf-c,1))
$(eval $(call find_lib,libfstrm,0.2))
$(eval $(call find_bin,protoc-c))
$(eval $(call find_bin,lcov))
$(eval $(call find_bin,luacov))

# Lookup SONAME
$(eval $(call find_soname,libknot))
$(eval $(call find_soname,libzscanner))

ifeq ($(libknot_SONAME),)
  $(error "Unable to resolve libknot_SONAME, update find_soname in platform.mk")
endif
ifeq ($(libzscanner_SONAME),)
  $(error "Unable to resolve libzscanner_SONAME, update find_some in platform.mk")
endif

# Find Go version and platform
GO_VERSION := $(shell $(GO) version 2>/dev/null)
ifeq ($(GO_VERSION),)
        GO_VERSION := 0
else
        GO_PLATFORM := $(word 2,$(subst /, ,$(word 4,$(GO_VERSION))))
        GO_VERSION := $(subst .,,$(subst go,,$(word 3,$(GO_VERSION))))
endif
$(eval $(call find_ver,go,$(GO_VERSION),16))

# Check if Go is able to build shared libraries
ifeq ($(HAS_go),yes)
ifneq ($(GO_PLATFORM),$(filter $(GO_PLATFORM),amd64 386 arm arm64))
HAS_go := no
endif
else
$(eval $(call find_ver,go,$(GO_VERSION),15))
ifeq ($HAS_go,yes)
ifneq ($(GO_PLATFORM),$(filter $(GO_PLATFORM),arm amd64))
HAS_go := no
endif
endif
endif

# check for fstrm and protobuf for dnstap
ifeq ($(HAS_libfstrm)|$(HAS_libprotobuf-c)|$(HAS_protoc-c),yes|yes|yes)
ENABLE_DNSTAP := yes
endif

# Overview
info:
	$(info Target:     Knot Resolver $(VERSION)-$(PLATFORM))
	$(info Compiler:   $(CC) $(BUILD_CFLAGS))
	$(info Linker:     $(CCLD) $(BUILD_LDFLAGS))
	$(info )
	$(info Variables)
	$(info ---------)
	$(info HARDENING:  $(HARDENING))
	$(info BUILDMODE:  $(BUILDMODE))
	$(info PREFIX:     $(PREFIX))
	$(info PREFIX:     $(PREFIX))
	$(info DESTDIR:    $(DESTDIR))
	$(info BINDIR:     $(BINDIR))
	$(info SBINDIR:    $(SBINDIR))
	$(info LIBDIR:     $(LIBDIR))
	$(info ETCDIR:     $(ETCDIR))
	$(info INCLUDEDIR: $(INCLUDEDIR))
	$(info MODULEDIR:  $(MODULEDIR))
	$(info )
	$(info Core Dependencies)
	$(info ------------)
	$(info [$(HAS_libknot)] libknot (lib))
	$(info [yes] $(if $(filter $(HAS_lmdb),yes),system,embedded) lmdb (lib))
	$(info [$(HAS_lua)] luajit (daemon))
	$(info [$(HAS_libuv)] libuv (daemon))
	$(info [$(HAS_gnutls)] libgnutls (daemon))
	$(info )
	$(info Optional)
	$(info --------)
	$(info [$(HAS_doxygen)] doxygen (doc))
	$(info [$(HAS_sphinx-build)] sphinx-build (doc))
	$(info [$(HAS_breathe)] python-breathe (doc))
	$(info [$(HAS_go)] go (modules/go, Go buildmode=c-shared support))
	$(info [$(HAS_cmocka)] cmocka (tests/unit))
	$(info [$(HAS_libsystemd)] systemd (daemon))
#	$(info [$(HAS_nettle)] nettle (modules/cookies))
	$(info [$(HAS_ltn12)] Lua socket ltn12 (trust anchor bootstrapping))
	$(info [$(HAS_ssl.https)] Lua ssl.https (trust anchor bootstrapping))
	$(info [$(HAS_libedit)] libedit (client))
	$(info [$(HAS_libfstrm)] libfstrm (modules/dnstap))
	$(info [$(HAS_libprotobuf-c)] libprotobuf-c (modules/dnstap))
	$(info [$(HAS_protoc-c)] proto-c (modules/dnstap))
	$(info [$(HAS_lcov)] lcov (code coverage))
	$(info [$(HAS_luacov)] luacov (code coverage))
	$(info )

# Verify required dependencies are met, as listed above
ifeq ($(HAS_libknot),no)
	$(error libknot >= $(KNOT_MINVER) required)
endif
ifeq ($(HAS_libzscanner),no)
	$(error libzscanner >= $(KNOT_MINVER) required)
endif
ifeq ($(HAS_libdnssec),no)
	$(error libdnssec >= $(KNOT_MINVER) required)
endif
ifeq ($(HAS_lua),no)
	$(error luajit required)
endif
ifeq ($(HAS_libuv),no)
	$(error libuv >= 1.0 required)
endif
ifeq ($(HAS_gnutls),no)
	$(error gnutls required)
endif


BUILD_CFLAGS += $(libknot_CFLAGS) $(libuv_CFLAGS) $(nettle_CFLAGS) $(cmocka_CFLAGS) $(lua_CFLAGS) $(libdnssec_CFLAGS) $(libsystemd_CFLAGS)
BUILD_CFLAGS += $(addprefix -I,$(wildcard contrib/ccan/*) contrib/murmurhash3)

# Work around luajit on OS X
ifeq ($(PLATFORM), Darwin)
ifneq (,$(findstring luajit, $(lua_LIBS)))
	lua_LIBS += -pagezero_size 10000 -image_base 100000000
endif
endif

# Check if it has nettle to support DNS cookies

# temporarily turn off cookies
#ifeq ($(HAS_nettle), yes)
#BUILD_CFLAGS += -DENABLE_COOKIES
#ENABLE_COOKIES := yes
#endif
ENABLE_COOKIES := no

# Installation directories
$(DESTDIR)$(MODULEDIR):
	$(INSTALL) -d $@
$(DESTDIR)$(ETCDIR):
	$(INSTALL) -m 0755 -d $@

# Sub-targets
include contrib/contrib.mk
include coverage.mk
include lib/lib.mk
include client/client.mk
include daemon/daemon.mk
include modules/modules.mk
include tests/tests.mk
include doc/doc.mk
include etc/etc.mk
include bench/bench.mk

=== tests/deckard/Makefile ===
# Defaults
PYTHON ?= python3
LIBEXT := .so
PLATFORM := $(shell uname -s)
ifeq ($(PLATFORM),Darwin)
	LIBEXT := .dylib
endif

# Dependencies
include platform.mk
libcwrap_DIR := contrib/libswrap
libcwrap_cmake_DIR := $(libcwrap_DIR)/obj
libcwrap=$(abspath $(libcwrap_cmake_DIR))/src/libsocket_wrapper$(LIBEXT).0
ifeq ($(PLATFORM),Darwin)
	libcwrap=$(abspath $(libcwrap_cmake_DIR))/src/libsocket_wrapper.0$(LIBEXT)
endif
libfaketime_DIR := contrib/libfaketime
libfaketime := $(abspath $(libfaketime_DIR))/src/libfaketime$(LIBEXT).1

# Platform-specific targets
ifeq ($(PLATFORM),Darwin)
	libfaketime := $(abspath $(libfaketime_DIR))/src/libfaketime.1$(LIBEXT)
	preload_syms := DYLD_LIBRARY_PATH=$(DYLD_LIBRARY_PATH) DYLD_FORCE_FLAT_NAMESPACE=1 DYLD_INSERT_LIBRARIES="$(libfaketime):$(libcwrap)"
else
	preload_syms := LD_PRELOAD="$(libfaketime):$(libcwrap)"
endif


# Targets
all:
	@echo "Deckard is now run using *run.sh scripts in its root directory."
	@echo "To build the dependencies (libfaketime and libcwrap) run 'make depend'."
	exit 1
depend: $(libfaketime) $(libcwrap)
	@echo "export DONT_FAKE_MONOTONIC=1" > env.sh
	@echo "export $(preload_syms)" >> env.sh

# Synchronize submodules
submodules: .gitmodules
	@git submodule update --init
# indirection through submodules target is necessary
# to prevent make from running "git submodule" commands in parallel
$(libfaketime_DIR)/Makefile $(libcwrap_DIR)/CMakeLists.txt: submodules
$(libfaketime): $(libfaketime_DIR)/Makefile
	@CFLAGS="-O0 -g" $(MAKE) -s -C $(libfaketime_DIR)
$(libcwrap_cmake_DIR):$(libcwrap_DIR)/CMakeLists.txt
	@mkdir -p $(libcwrap_cmake_DIR)
$(libcwrap_cmake_DIR)/Makefile: $(libcwrap_cmake_DIR)
	@cd $(libcwrap_cmake_DIR); cmake ..
$(libcwrap): $(libcwrap_cmake_DIR)/Makefile
	@CFLAGS="-O0 -g" $(MAKE) -s -C $(libcwrap_cmake_DIR)


.PHONY: submodules depend all

check:
	@echo Running unittests using pytest
	${PYTHON} -m pytest

=== tests/deckard/requirements.txt ===
dnspython>=1.15
dpkt
Jinja2>=2.8
PyYAML
python-augeas
pytest>=3.4
pytest-xdist

=== tests/pytests/rehandshake/Makefile ===
CC=gcc
CFLAGS_TLS=-DDEBUG -ggdb3 -O0 -lgnutls -luv
CFLAGS_TCP=-DDEBUG -ggdb3 -O0 -luv

all: tcproxy tlsproxy

tlsproxy: tls-proxy.o tlsproxy.o
	$(CC) tls-proxy.o tlsproxy.o -o tlsproxy $(CFLAGS_TLS)

tls-proxy.o: tls-proxy.c tls-proxy.h array.h
	$(CC) -c -o $@ $< $(CFLAGS_TLS)

tlsproxy.o: tlsproxy.c tls-proxy.h
	$(CC) -c -o $@ $< $(CFLAGS_TLS)

tcproxy: tcp-proxy.o tcproxy.o
	$(CC) tcp-proxy.o tcproxy.o -o tcproxy $(CFLAGS_TCP)

tcp-proxy.o: tcp-proxy.c tcp-proxy.h array.h
	$(CC) -c -o $@ $< $(CFLAGS_TCP)

tcproxy.o: tcproxy.c tcp-proxy.h
	$(CC) -c -o $@ $< $(CFLAGS_TCP)

clean:
	rm -f tcp-proxy.o tcproxy.o tcproxy tls-proxy.o tlsproxy.o tlsproxy

.PHONY: all clean

=== tests/deckard/contrib/libfaketime/Makefile ===
INSTALL ?= install

UNAME=$(shell uname)
SELECTOR:=$(shell if test "${UNAME}" = "Darwin" ; then echo "-f Makefile.OSX" ; fi)

all:
	$(MAKE) $(SELECTOR) -C src all

test:
	$(MAKE) $(SELECTOR) -C test all

install:
	$(MAKE) $(SELECTOR) -C src install
	$(MAKE) $(SELECTOR) -C man install
	$(INSTALL) -dm0755 "${DESTDIR}${PREFIX}/share/doc/faketime/"
	$(INSTALL) -m0644 README "${DESTDIR}${PREFIX}/share/doc/faketime/README"
	$(INSTALL) -m0644 NEWS "${DESTDIR}${PREFIX}/share/doc/faketime/NEWS"

uninstall:
	$(MAKE) $(SELECTOR) -C src uninstall
	$(MAKE) $(SELECTOR) -C man uninstall
	rm -f "${DESTDIR}${PREFIX}/share/doc/faketime/README"
	rm -f "${DESTDIR}${PREFIX}/share/doc/faketime/NEWS"
	rmdir "${DESTDIR}${PREFIX}/share/doc/faketime"

clean:
	$(MAKE) $(SELECTOR) -C src clean
	$(MAKE) $(SELECTOR) -C test clean

distclean:
	$(MAKE) $(SELECTOR) -C src distclean
	$(MAKE) $(SELECTOR) -C test distclean

.PHONY: all test install uninstall clean distclean

=== tests/deckard/contrib/libswrap/CMakeLists.txt ===
project(socket_wrapper C)

# Required cmake version
cmake_minimum_required(VERSION 2.8.5)

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

set(APPLICATION_VERSION_MAJOR "1")
set(APPLICATION_VERSION_MINOR "1")
set(APPLICATION_VERSION_PATCH "7")

set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")

# SOVERSION scheme: CURRENT.AGE.REVISION
#   If there was an incompatible interface change:
#     Increment CURRENT. Set AGE and REVISION to 0
#   If there was a compatible interface change:
#     Increment AGE. Set REVISION to 0
#   If the source code was changed, but there were no interface changes:
#     Increment REVISION.
set(LIBRARY_VERSION "0.1.7")
set(LIBRARY_SOVERSION "0")

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH
  ${CMAKE_SOURCE_DIR}/cmake/Modules
)

# add definitions
include(DefineCMakeDefaults)
include(DefinePlatformDefaults)
include(DefineCompilerFlags)
include(DefineInstallationPaths)
include(DefineOptions.cmake)
include(CPackConfig.cmake)

# disallow in-source build
include(MacroEnsureOutOfSourceBuild)
macro_ensure_out_of_source_build("${PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")

# Find out if we have threading available
set(CMAKE_THREAD_PREFER_PTHREADS ON)
find_package(Threads)

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# check subdirectories
add_subdirectory(src)

if (UNIT_TESTING)
    find_package(cmocka 0.4.1 REQUIRED)

    include(AddCMockaTest)
    add_subdirectory(tests)
endif (UNIT_TESTING)

# pkg-config file
get_filename_component(SOCKET_WRAPPER_LIB ${SOCKET_WRAPPER_LOCATION} NAME)

configure_file(socket_wrapper.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper.pc @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper.pc
  DESTINATION
    ${LIB_INSTALL_DIR}/pkgconfig
  COMPONENT
    pkgconfig
)

# cmake config files
configure_file(socket_wrapper-config-version.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config-version.cmake @ONLY)
configure_file(socket_wrapper-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config.cmake @ONLY)
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config.cmake
    DESTINATION
        ${CMAKE_INSTALL_DIR}/socket_wrapper
    COMPONENT
        devel
)

add_subdirectory(doc)

=== tests/deckard/contrib/libfaketime/src/Makefile ===
#
# Notes:
#
#   * Compilation Defines:
#
#     FAKE_STAT
#         - Enables time faking also for files' timestamps.
#
#     NO_ATFILE
#         - Disables support for the fstatat() group of functions
#
#     PTHREAD_SINGLETHREADED_TIME
#         - Define this if you want to single-thread time() ... there ARE
#           possible caching side-effects in a multithreaded environment
#           without this, but the performance impact may require you to
#           try it unsynchronized.
#
#     FAKE_INTERNAL_CALLS
#         - Also intercept libc internal __functions, e.g. not just time(),
#           but also __time(). Enhances compatibility with applications
#           that make use of low-level system calls, such as Java Virtual
#           Machines.
#
#     FAKE_SLEEP
#         - Also intercept sleep(), nanosleep(), usleep(), alarm(), [p]poll()
#
#     FAKE_TIMERS
#         - Also intercept timer_settime() and timer_gettime()
#
#     FAKE_PTHREAD
#         - Intercept pthread_cond_timedwait
#
#     MULTI_ARCH
#  	  - If MULTI_ARCH is set, the faketime wrapper program will put a literal
#           $LIB into the LD_PRELOAD environment variable it creates, which makes
#           ld automatically choose the correct library version to use for the
#           target binary. Use for Linux platforms with Multi-Arch support only!
#
#   * Compilation addition: second libMT target added for building the pthread-
#     enabled library as a separate library
#
#   * Compilation switch change: previous versions compiled using '-nostartfiles'
#     This is no longer the case since there is a 'startup' constructor for the library
#     which is used to activate the start-at times when specified. This also initializes
#     the dynamic disabling of the FAKE_STAT calls.
#
# By default, libfaketime will be compiled for your system's default architecture.
# To build 32-bit libraries and binaries, add -m32 to CFLAGS and LDFLAGS.
#
# Change PREFIX to where you want libfaketime (libraries and wrapper binary) installed.
# LIBDIRNAME is relative to PREFIX. The default is to install into $PREFIX/lib/faketime,
# but you can set LIBDIRNAME to, e.g., /lib64 if you want to install it elsewhere.
# LIBDIRNAME has been introduced to support MultiLib systems. Please do not change the 
# default value on MultiArch systems. 
#
# For testing in the current directory without installation, try make PREFIX= LIBDIRNAME='.'

CC ?= gcc
INSTALL ?= install

PREFIX ?= /usr/local
LIBDIRNAME ?= /lib/faketime
PLATFORM ?=$(shell uname)

CFLAGS += -std=gnu99 -Wall -Wextra -Werror -Wno-nonnull-compare -DFAKE_PTHREAD -DFAKE_STAT -DFAKE_SLEEP -DFAKE_TIMERS -DFAKE_INTERNAL_CALLS -fPIC -DPREFIX='"'$(PREFIX)'"' -DLIBDIRNAME='"'$(LIBDIRNAME)'"'
ifeq ($(PLATFORM),SunOS)
CFLAGS += -D__EXTENSIONS__ -D_XOPEN_SOURCE=600
endif

LIB_LDFLAGS += -shared

LDFLAGS += -lpthread
ifneq ($(PLATFORM),SunOS)
LDFLAGS += -Wl,--version-script=libfaketime.map
endif

LDADD += -ldl -lm -lrt
BIN_LDFLAGS += -lrt

SRC = libfaketime.c
LIBS_OBJ = libfaketime.o libfaketimeMT.o
BINS = faketime

SONAME = 1
LIBS = libfaketime.so.${SONAME} libfaketimeMT.so.${SONAME}

all: ${LIBS} ${BINS}

libfaketimeMT.o: EXTRA_FLAGS := -DPTHREAD_SINGLETHREADED_TIME

${LIBS_OBJ}: libfaketime.c
	${CC} -o $@ -c ${CFLAGS} ${CPPFLAGS} ${EXTRA_FLAGS} $<

%.so.${SONAME}: %.o libfaketime.map
	${CC} -o $@ -Wl,-soname,$@ ${LDFLAGS} ${LIB_LDFLAGS} $< ${LDADD}

${BINS}: faketime.c
	${CC} -o $@ ${CFLAGS} ${CPPFLAGS} ${EXTRA_FLAGS} $< ${LDFLAGS} ${BIN_LDFLAGS}

clean:
	@rm -f ${LIBS_OBJ} ${LIBS} ${BINS}

distclean: clean
	@echo

install: ${LIBS} ${BINS}
	@echo
	@echo "Copying the faketime libraries to ${DESTDIR}${PREFIX}${LIBDIRNAME} and the faketime wrapper script to ${DESTDIR}${PREFIX}/bin ..."
	$(INSTALL) -dm0755 "${DESTDIR}${PREFIX}${LIBDIRNAME}/"
	$(INSTALL) -m0644 ${LIBS} "${DESTDIR}${PREFIX}${LIBDIRNAME}/"
	$(INSTALL) -Dm0755 faketime "${DESTDIR}${PREFIX}/bin/faketime"

uninstall:
	for f in ${LIBS}; do rm -f "${DESTDIR}${PREFIX}${LIBDIRNAME}/$$f"; done
	rmdir "${DESTDIR}${PREFIX}${LIBDIRNAME}"
	rm -f "${DESTDIR}${PREFIX}/bin/faketime"

.PHONY: all clean distclean install uninstall

=== tests/deckard/contrib/libfaketime/test/Makefile ===
CC = gcc

CFLAGS = -std=gnu99 -Wall -DFAKE_STAT -Werror -Wextra
LDFLAGS = -lrt -lpthread

SRC = timetest.c
OBJ = ${SRC:.c=.o}

all: timetest test

.c.o:
	${CC} -c ${CFLAGS} $<

timetest: ${OBJ}
	${CC} -o $@ ${OBJ} ${LDFLAGS}

test: timetest functest
	@echo
	@./test.sh

# run functional tests
functest:
	./testframe.sh functests

clean:
	@rm -f ${OBJ} timetest

distclean: clean
	@echo

.PHONY: all test clean distclean

=== tests/deckard/contrib/libswrap/src/CMakeLists.txt ===
project(libsocket_wrapper C)

include_directories(${CMAKE_BINARY_DIR})

add_library(socket_wrapper SHARED socket_wrapper.c)

target_link_libraries(socket_wrapper ${SWRAP_REQUIRED_LIBRARIES})

install(
  TARGETS
    socket_wrapper
  RUNTIME DESTINATION ${BIN_INSTALL_DIR}
  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

set_target_properties(
  socket_wrapper
    PROPERTIES
      VERSION
        ${LIBRARY_VERSION}
      SOVERSION
        ${LIBRARY_SOVERSION}
)

set(SOCKET_WRAPPER_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}socket_wrapper${CMAKE_SHARED_LIBRARY_SUFFIX}" PARENT_SCOPE)

=== tests/deckard/contrib/libswrap/tests/CMakeLists.txt ===
project(tests C)

include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/src
  ${CMOCKA_INCLUDE_DIR}
)

set(TORTURE_LIBRARY torture)

# RFC862 echo server
add_executable(echo_srv echo_srv.c)
target_link_libraries(echo_srv ${SWRAP_REQUIRED_LIBRARIES})

add_library(${TORTURE_LIBRARY} STATIC torture.c)
target_link_libraries(${TORTURE_LIBRARY}
    ${CMOCKA_LIBRARY}
    ${SWRAP_REQUIRED_LIBRARIES})

set(SWRAP_TESTS
    test_ioctl
    test_tcp_listen
    test_echo_tcp_socket
    test_echo_tcp_connect
    test_echo_tcp_bind
    test_echo_tcp_socket_options
    test_echo_tcp_sendmsg_recvmsg
    test_echo_tcp_write_read
    test_echo_tcp_writev_readv
    test_echo_tcp_get_peer_sock_name
    test_echo_udp_sendto_recvfrom
    test_echo_udp_send_recv
    test_echo_udp_sendmsg_recvmsg
    test_swrap_unit)

if (HAVE_STRUCT_MSGHDR_MSG_CONTROL)
    set(SWRAP_TESTS ${SWRAP_TESTS} test_sendmsg_recvmsg_fd)
endif (HAVE_STRUCT_MSGHDR_MSG_CONTROL)

foreach(_SWRAP_TEST ${SWRAP_TESTS})
    add_cmocka_test(${_SWRAP_TEST} ${_SWRAP_TEST}.c ${TORTURE_LIBRARY})

    if (OSX)
        set_property(
            TEST
                ${_SWRAP_TEST}
            PROPERTY
                ENVIRONMENT DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${SOCKET_WRAPPER_LOCATION})
    else ()
        set_property(
            TEST
                ${_SWRAP_TEST}
            PROPERTY
                ENVIRONMENT LD_PRELOAD=${SOCKET_WRAPPER_LOCATION})
    endif()
endforeach()

=== debian/changelog ===
knot-resolver (3.2.1-3) unstable; urgency=medium

  * knot-resolver-module-http is arch: all, not arch: any
  * Explicitly list all non-arm64 architectures

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 08 Mar 2019 00:56:09 -0500

knot-resolver (3.2.1-2) unstable; urgency=medium

  * Standards-Version: move to 4.3.0 (no changes needed)
  * move to debhelper 12
  * Avoid breakage when built against knot-dns 2.8.0
  * d/tests/control: wrap-and-sort
  * Drop libkres9 and libkres-dev packages (Closes: #923970)
  * avoid clobbering CXXFLAGS when compiling lua-aho-corasick
  * missing-sources: updated dygraph-combined.js to match minified version
  * avoid shipping pre-built glyphicons-halflings-regular.woff2

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 07 Mar 2019 16:23:16 -0500

knot-resolver (3.2.1-1) unstable; urgency=medium

  * new upstream release (Closes: #922172)
  * Update symbols file for 3.2.1 release

 -- Ondřej Surý <ondrej@debian.org>  Thu, 21 Feb 2019 09:42:37 +0000

=== debian/control ===
Source: knot-resolver
Section: net
Priority: optional
Maintainer: knot-resolver packagers <knot-resolver@packages.debian.org>
Uploaders:
 Ondřej Surý <ondrej@debian.org>,
 Daniel Kahn Gillmor <dkg@fifthhorseman.net>,
Build-Depends-Indep:
 doxygen,
 python3-breathe,
 python3-sphinx,
 python3-sphinx-rtd-theme,
Build-Depends:
 debhelper-compat (= 12),
 dns-root-data,
 gnutls-bin <!nocheck>,
 knot-dnsutils <!nocheck>,
 libcmocka-dev (>= 1.0.0),
 libedit-dev,
 libgeoip-dev,
 libgnutls28-dev,
 libknot-dev (>= 2.7.2),
 libknot-dev (<< 2.8.0),
 liblmdb-dev,
 libluajit-5.1-dev,
 libsystemd-dev (>= 227) [linux-any],
 libuv1-dev,
 luajit,
 pkg-config,
 socat <!nocheck>,
Standards-Version: 4.3.0
Homepage: https://www.knot-resolver.cz/
Vcs-Browser: https://salsa.debian.org/dns-team/knot-resolver
Vcs-Git: https://salsa.debian.org/dns-team/knot-resolver.git
Rules-Requires-Root: no

Package: knot-resolver
# intended to be "Architecture: any [!arm64]", see #907729
Architecture: amd64 armel armhf i386 mips mips64el mipsel ppc64 ppc64el
Depends:
 adduser,
 dns-root-data,
 lua-sec,
 lua-socket,
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
  libkres9 (<< 3.2.1-2),
Breaks:
  libkres9 (<< 3.2.1-2),
Recommends:
 knot-resolver-module-http,
 lua-basexx,
Description: caching, DNSSEC-validating DNS resolver
 The Knot DNS Resolver is a caching full resolver implementation
 written in C and LuaJIT, including both a resolver library and a
 daemon. Modular architecture of the library keeps the core tiny and
 efficient, and provides a state-machine like API for
 extensions. There are three built-in modules - iterator, cache,
 validator, and many external.
 .
 The Lua modules, switchable and shareable cache, and fast FFI
 bindings makes it great to tap into resolution process, or be used
 for your recursive DNS service. It's the OpenResty of DNS.
 .
 The server adopts a different scaling strategy than the rest of the
 DNS recursors - no threading, shared-nothing architecture (except
 MVCC cache that may be shared). You can start and stop additional
 nodes depending on the contention without downtime.

Package: knot-resolver-module-http
Architecture: all
Depends:
 fonts-glyphicons-halflings,
 libjs-bootstrap,
 libjs-d3,
 libjs-jquery,
 lua-http,
 lua-mmdb,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 knot-resolver-module-tinyweb (<< 1.1.0~git20160713-1~),
Description: HTTP/2 module for Knot Resolver
 The Knot DNS Resolver is a caching full resolver implementation
 written in C and LuaJIT, including both a resolver library and a
 daemon. Modular architecture of the library keeps the core tiny and
 efficient, and provides a state-machine like API for
 extensions. There are three built-in modules - iterator, cache,
 validator, and many external.
 .
 This package contains HTTP/2 module for local visualization of the
 resolver cache and queries.

Package: knot-resolver-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 libjs-jquery,
 libjs-underscore,
 ${misc:Depends},
Description: Documentation for Knot Resolver
 The Knot DNS Resolver is a caching full resolver implementation
 written in C and LuaJIT, including both a resolver library and a
 daemon. Modular architecture of the library keeps the core tiny and
 efficient, and provides a state-machine like API for
 extensions. There are three built-in modules - iterator, cache,
 validator, and many external.
 .
 This package contains Knot Resolver Documentation.

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -fno-omit-frame-pointer
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export ARCH=$(DEB_HOST_GNU_CPU)
export PREFIX=/usr
export MODULEDIR=/usr/lib/knot-resolver
export ETCDIR=/etc/knot-resolver

%:
	dh $@

override_dh_auto_clean-indep:
	dh_auto_clean -- doc-clean http-clean

override_dh_auto_build-arch:
	CFLAGS="$${CFLAGS} -DNDEBUG" dh_auto_build -- V=1 BUILDMODE=static lib
	CFLAGS="$${CFLAGS} -DNDEBUG" dh_auto_build -- V=1 \
	 ROOTHINTS=/usr/share/dns/root.hints \
	 KEYFILE_DEFAULT=/usr/share/dns/root.key

override_dh_auto_build-indep:
	dh_auto_build -- V=1 http
	dh_auto_build -- V=1 doc-doxygen
	cd doc && sphinx-build -b html -D html_theme=nature . html

override_dh_auto_install-arch:
	dh_auto_install --destdir=debian/tmp -- V=1 KEYFILE_DEFAULT=/usr/share/dns/root.key
	rm -f debian/tmp/etc/knot-resolver/root.hints debian/tmp/etc/knot-resolver/icann-ca.pem

override_dh_auto_install-indep:
# install just the http/2 module
	make http-install DESTDIR=debian/tmp V=1

override_dh_installinit:
	dh_installinit -pknot-resolver --name=kresd --no-start

override_dh_installsystemd:
	dh_installsystemd -pknot-resolver --name=kresd kresd-tls.socket kresd.socket

override_dh_auto_test-indep:
override_dh_auto_test-arch:
	dh_auto_test -- V=1
ifeq (, $(filter nocheck, $(DEB_BUILD_OPTIONS)))
	mkdir -p test-modules && (cd test-modules && ln -sf ../modules/*/*.lua ../modules/*/*.so ../modules/policy/lua-aho-corasick/*.lua ../modules/policy/lua-aho-corasick/*.so ../daemon/lua/* ./)
	MODULE_DIR=$(CURDIR)/test-modules LD_LIBRARY_PATH=$(CURDIR)/lib KRESD=$(CURDIR)/daemon/kresd debian/tests/roundtrip
endif

override_dh_missing:
	dh_missing --fail-missing

override_dh_installchangelogs:
	dh_installchangelogs NEWS

## knot-resolver 5.1.1

=== meson_options.txt ===
# Configuration options
# SPDX-License-Identifier: GPL-3.0-or-later

option(
  'keyfile_default',
  type: 'string',
  value: 'root.keys',
  description: 'built-in path to DNSSEC trust anchors file',
)

option(
  'managed_ta',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'auto-manage DNSSEC trust anchors (RFC 5011)',
)

option(
  'root_hints',
  type: 'string',
  value: 'root.hints',
  description: 'built-in path to root.hints file',
)

option(
  'install_kresd_conf',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'creates kresd.conf in config directory',
)

option(
  'install_root_keys',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'installs DNSSEC TA to keyfile_default location',
)

option(
  'verbose_log',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'support verbose logging',
)

option(
  'user',
  type: 'string',
  value: 'knot-resolver',
  description: 'user which is used for running kresd',
)

option(
  'group',
  type: 'string',
  value: 'knot-resolver',
  description: 'group which is used for running kresd',
)

option(
  'sendmmsg',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'use sendmmsg syscall towards clients',
)

## Systemd
option(
  'systemd_files',
  type: 'combo',
  choices: [
    'disabled',
    'enabled',
  ],
  value: 'disabled',
  description: 'installs systemd-related files',
)


# Component options
option(
  'bench',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'disabled',
  description: 'build benchmarks',
)

option(
  'client',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'build kresc client binary',
)

option(
  'utils',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'build kres utilities',
)

option(
  'dnstap',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'build dnstap module',
)

option(
  'doc',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'disabled',
  description: 'html documentation dependencies and installation',
)

option(
  'config_tests',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'postinstall config tests',
)

option(
  'extra_tests',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'disabled',
  description: 'postinstall tests with extra dependencies',
)

option(
  'unit_tests',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'cmocka unit tests',
)

=== distro/turris/Makefile ===
# Copyright (C) 2015-2019 CZ.NIC, z. s. p. o. (https://www.nic.cz/)
# SPDX-License-Identifier: GPL-2.0

PKG_RELRO_FULL:=0

include $(TOPDIR)/rules.mk

PKG_NAME:=knot-resolver
PKG_VERSION:=__VERSION__
PKG_RELEASE:=1

PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.xz

PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)-$(PKG_VERSION)

PKG_MAINTAINER:=Knot DNS <knot-dns@labs.nic.cz>
PKG_LICENSE:=GPL-3.0

PKG_INSTALL:=1

include $(INCLUDE_DIR)/package.mk

define Package/knot-resolver
	SECTION:=net
	CATEGORY:=Network
	SUBMENU:=IP Addresses and Names
	TITLE:=Knot DNS Resolver
	URL:=https://gitlab.labs.nic.cz/knot/resolver
	DEPENDS=+knot-libs +knot-libzscanner +libuv +luajit +dnssec-rootkey +resolver-conf +libstdcpp
	PROVIDES:=dns-resolver
endef

define Package/knot-resolver/description
  The Knot DNS Resolver is a minimalistic caching resolver implementation.
endef

MAKE_FLAGS += \
	PREFIX=/usr \
	ETCDIR=/etc/kresd

define Build/Patch
	$(Build/Patch/Default)
	cd $(PKG_BUILD_DIR) && \
	sed -i -e 's/\(.*find_lib,hiredis.*\)/HAS_hiredis := no/' \
	       -e 's/\(.*find_lib,libmemcached.*\)/HAS_libmemcached := no/' Makefile
endef

define Package/knot-resolver/install
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/*bin/kresd $(1)/usr/bin/

	$(INSTALL_DIR) $(1)/usr/lib
	$(CP) $(PKG_INSTALL_DIR)/usr/lib/libkres.so* $(1)/usr/lib
	$(CP) $(PKG_INSTALL_DIR)/usr/lib/kdns_modules $(1)/usr/lib

	$(INSTALL_DIR) $(1)/etc/init.d
	$(INSTALL_BIN) ./files/kresd.init $(1)/etc/init.d/kresd

	$(INSTALL_DIR) $(1)/etc/kresd
	$(CP) $(PKG_BUILD_DIR)/etc/icann-ca.pem $(1)/etc/kresd
	$(CP) $(PKG_BUILD_DIR)/etc/root.hints $(1)/etc/kresd
	$(INSTALL_BIN) ./files/kresd.postinst $(1)/etc/kresd/kresd.postinst.sh
	$(INSTALL_BIN) ./files/convert_config.sh $(1)/etc/kresd/convert_config.sh
endef

define Package/$(PKG_NAME)/postinst
#!/bin/sh
set -x
if [ -z "$$IPKG_INSTROOT" ]; then
/etc/init.d/dnsmasq restart
sleep 2 # Cooldown for above (problems in times of reinstall)
/etc/kresd/kresd.postinst.sh && rm /etc/kresd/kresd.postinst.sh
/etc/kresd/convert_config.sh && rm /etc/kresd/convert_config.sh
if [ "`uci -q get resolver.common.prefered_resolver`" = kresd ] && uci -q get resolver.common.forward_upstream | egrep -q '(1|yes|true|enabled|on)'; then
	ping -c 1 api.turris.cz 2> /dev/null >&2 || {
		uci set resolver.common.forward_upstream=0
		uci commit
		/etc/init.d/resolver restart
		if ping -c 1 api.turris.cz 2> /dev/null >&2; then
			create_notification -s error "DNS servery vašeho poskytovatele internetu nefungují úplně dobře - pravděpodobně nepodporují DNSSEC. Bylo proto vypnuto forwardování a váš router bude nyní vyhodnocovat DNS dotazy sám." "Your ISPs DNS servers does not work properly - most likely they don't support DNSSEC. Therefore DNS forwarding was turned off and your router will now resolve all DNS queries by itself."
		else
			uci set resolver.common.forward_upstream=1
			uci commit
			/etc/init.d/resolver restart
		fi
	}
fi
fi
endef

define Package/$(PKG_NAME)/prerm
#!/bin/sh
set -ex
if [ -z "$$IPKG_INSTROOT" ]; then
# Remove the script if it is there.
if [ -e /etc/init.d/kresd ] ; then /etc/init.d/kresd stop ; /etc/init.d/kresd disable ;  fi
fi
endef

define Package/knot-resolver/postrm
#!/bin/sh
if [ -z "$$IPKG_INSTROOT" ]; then
[ \! -x /etc/init.d/resolver ] || /etc/init.d/resolver restart
fi
endef

$(eval $(call BuildPackage,knot-resolver))

=== tests/integration/deckard/requirements.txt ===
dnspython>=1.15
dpkt
Jinja2>=2.8
PyYAML
python-augeas
pytest>=3.4
pytest-xdist
pyroute2

=== debian/changelog ===
knot-resolver (5.1.1-0.1ubuntu1) groovy; urgency=medium

  * d/control:
    - knot-resolver-module-http Architecture can't be 'any' since it
      doesn't build on arm64/s390x; change it to match archs from
      main knot-resolver package
  * d/t/control, d/t/roundtrip:
    - pull test fixes from Debian WIP:
      https://salsa.debian.org/dns-team/knot-resolver/-/merge_requests/4

 -- Dan Streetman <ddstreet@canonical.com>  Tue, 30 Jun 2020 18:28:40 -0400

knot-resolver (5.1.1-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release:
    - mitigation for NXNSAttack DNS protocol vulnerability
      [CVE-2020-12667] (Closes: #961076)

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sun, 14 Jun 2020 06:24:58 +0200

knot-resolver (5.0.1-2) unstable; urgency=medium

  * Merge the indep and arch build, it doesn't really work with meson
  * With new layout, the http module has to be converted to arch:any

 -- Ondřej Surý <ondrej@debian.org>  Fri, 28 Feb 2020 10:10:07 +0100

knot-resolver (5.0.1-1) unstable; urgency=medium

  * Adapt d/rules to meson-build
  * Use wrap-and-sort -a to sort the d/control and d/tests/control
  * Remove debian/patches, they are no longer applicable
  * Enable upstream systemd files, enable config_tests
  * Update the list of installed and not-installed files
  * Enable the documentation build and build it in dh_auto_build target
  * Merge manpages installation to knot-resolver.install
  * Don't call dh_installsystemd, remove the extra Debian unit files
  * Use deb-systemd-invoke instead of systemctl in the maintainer scripts
  * Enable dnstap and add libprotobuf-c-dev to B-D

 -- Ondřej Surý <ondrej@debian.org>  Sat, 22 Feb 2020 21:14:47 +0100

=== debian/control ===
Source: knot-resolver
Section: net
Priority: optional
Maintainer: knot-resolver packagers <knot-resolver@packages.debian.org>
Uploaders: Ondřej Surý <ondrej@debian.org>,
           Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Build-Depends: debhelper-compat (= 12),
               dns-root-data,
               doxygen,
               gnutls-bin <!nocheck>,
               knot-dnsutils <!nocheck>,
               libcmocka-dev (>= 1.0.0),
               libedit-dev,
               libfstrm-dev,
               libgnutls28-dev,
               libknot-dev (>= 2.8.0~),
               liblmdb-dev,
               libluajit-5.1-dev,
               libprotobuf-c-dev,
               libsystemd-dev (>= 227) [linux-any],
               libuv1-dev,
               lua-cqueues,
               luajit,
               meson,
               ninja-build,
               pkg-config,
               protobuf-c-compiler,
               python3-breathe,
               python3-sphinx,
               python3-sphinx-rtd-theme,
               socat <!nocheck>
Standards-Version: 4.3.0
Homepage: https://www.knot-resolver.cz/
Vcs-Browser: https://salsa.debian.org/dns-team/knot-resolver
Vcs-Git: https://salsa.debian.org/dns-team/knot-resolver.git
Rules-Requires-Root: no

Package: knot-resolver
# Doesn't build on s390x due to missing luajit
#   https://github.com/LuaJIT/LuaJIT/issues/397
# Doesn't build on arm64 due to luajit issue
#   https://gitlab.nic.cz/knot/knot-resolver/issues/216
Architecture: amd64 armel armhf i386 mips mips64el mipsel ppc64 ppc64el
Depends: adduser,
         dns-root-data,
         lua-sec,
         lua-socket,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: libkres9 (<< 3.2.1-2)
Breaks: libkres9 (<< 3.2.1-2)
Recommends: knot-resolver-module-http,
            lua-basexx,
            lua-cqueues
Description: caching, DNSSEC-validating DNS resolver
 The Knot Resolver is a caching full resolver implementation
 written in C and LuaJIT, including both a resolver library and a
 daemon. Modular architecture of the library keeps the core tiny and
 efficient, and provides a state-machine like API for
 extensions. There are three built-in modules - iterator, cache,
 validator, and many external.
 .
 The Lua modules, switchable and shareable cache, and fast FFI
 bindings makes it great to tap into resolution process, or be used
 for your recursive DNS service. It's the OpenResty of DNS.
 .
 The server adopts a different scaling strategy than the rest of the
 DNS recursors - no threading, shared-nothing architecture (except
 MVCC cache that may be shared). You can start and stop additional
 nodes depending on the contention without downtime.

Package: knot-resolver-module-http
Architecture: amd64 armel armhf i386 mips mips64el mipsel ppc64 ppc64el
Depends: fonts-glyphicons-halflings,
         libjs-bootstrap,
         libjs-d3,
         libjs-jquery,
         lua-http,
         lua-mmdb,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: knot-resolver-module-tinyweb (<< 1.1.0~git20160713-1~)
Description: HTTP/2 module for Knot Resolver
 The Knot Resolver is a caching full resolver implementation
 written in C and LuaJIT, including both a resolver library and a
 daemon. Modular architecture of the library keeps the core tiny and
 efficient, and provides a state-machine like API for
 extensions. There are three built-in modules - iterator, cache,
 validator, and many external.
 .
 This package contains HTTP/2 module for local visualization of the
 resolver cache and queries.

Package: knot-resolver-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-jquery,
         libjs-underscore,
         ${misc:Depends}
Description: Documentation for Knot Resolver
 The Knot Resolver is a caching full resolver implementation
 written in C and LuaJIT, including both a resolver library and a
 daemon. Modular architecture of the library keeps the core tiny and
 efficient, and provides a state-machine like API for
 extensions. There are three built-in modules - iterator, cache,
 validator, and many external.
 .
 This package contains Knot Resolver Documentation.

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -fno-omit-frame-pointer
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-Dkeyfile_default=/usr/share/dns/root.key \
		-Dinstall_root_keys=disabled \
		-Dmanaged_ta=disabled \
		-Droot_hints=/usr/share/dns/root.hints \
		-Dinstall_kresd_conf=enabled \
		-Dsystemd_files=enabled \
		-Dclient=enabled \
		-Dutils=enabled \
		-Ddoc=enabled \
		-Ddnstap=enabled \
		-Dunit_tests=enabled \
		-Dconfig_tests=enabled \
		-Dextra_tests=disabled

override_dh_auto_build:
	dh_auto_build -- doc
	dh_auto_build

override_dh_installinit:
	dh_installinit -pknot-resolver --name=kresd --no-start

override_dh_missing:
	dh_missing --fail-missing

override_dh_installchangelogs:
	dh_installchangelogs NEWS

=== debian/tests/control ===
Tests: roundtrip
Depends: gnutls-bin,
         knot-dnsutils,
         knot-resolver,
         socat
Restrictions: needs-root

## knot-resolver 5.2.1

=== debian/changelog ===
knot-resolver (5.2.1-1) unstable; urgency=medium

  * New upstream release
  * Remove no longer needed upstream patch:
    0001-fix-map-command-on-32-bit-platforms-regressed-in-5.2.patch
    Note: it made the build non-reproducible. Thanks to Chris Lamb!
    (Closes: #976827)
  * Add lintian overrides for no-debconf-config tag and excessive line lengths
    in some d/missing-sources/ .js files
  * Fix no-symbols-control-file lintian override
  * Update d/copyright: remove no longer included entries and reorder File
    sections.
  * Bump Standards-Version to 4.5.1. No changes required

 -- Santiago Ruano Rincón <santiago@debian.org>  Tue, 15 Dec 2020 09:56:25 +0100

knot-resolver (5.2.0-2) unstable; urgency=low

  * Team upload.

  [ Jakub Ružička ]
  * bugfix release
  * debian/patches: fix map() command on 32-bit

  [ Dan Streetman ]
  * d/control: Change arch 'any' to specific list

  [ Santiago Ruano Rincón ]
  * Upload to unstable

 -- Santiago Ruano Rincón <santiago@debian.org>  Mon, 07 Dec 2020 17:29:18 +0100

knot-resolver (5.2.0-1) experimental; urgency=medium

  [ Jakub Ružička ]
  * new upstream release
  * use experimental in order to safely move to knot >= 3.0
  * debian/control: require libknot-dev >= 3.0.1
  * debian/control: add myself to Uploaders
  * debian/control: add lua-basexx build dep
  * debian/control: add libnghttp2 dep for DoH support
  * debian/control: use HTTP instead of HTTP/2 in desc
  * debian/not-installed: don't use sysusers

  [ Santiago Ruano Rincón ]
  * Set RELEASE to experimental in debian/salsa-ci.yml

 -- Jakub Ružička <jakub.ruzicka@nic.cz>  Fri, 20 Nov 2020 21:41:22 +0100

knot-resolver (5.1.3-1) unstable; urgency=low

  * New upstream release.
  * Add debconf template translations:
    - German (Closes: #969234)
    - Dutch (Closes: #969341)
    - French (Closes: #969478)
  * d/control: build again for arm64. See
    https://gitlab.nic.cz/knot/knot-resolver/-/merge_requests/1033
  * d/rules: really disable config_test on arm64. enable on other archs

 -- Santiago Ruano Rincón <santiago@debian.org>  Mon, 14 Sep 2020 11:24:10 +0200

knot-resolver (5.1.2-3) unstable; urgency=medium

  * d/tests/control: add skip-not-installable restriction to avoid failure
    state on arm64

 -- Santiago Ruano Rincón <santiago@debian.org>  Wed, 12 Aug 2020 22:24:46 +0200

knot-resolver (5.1.2-2) unstable; urgency=low

  * Add myself to Uploaders
  * debian/rules: disable config_tests on arm64
    https://gitlab.nic.cz/knot/knot-resolver/-/issues/593
  * knot-resolver-module-http: explicitly set non-arm64 architectures

 -- Santiago Ruano Rincón <santiago@debian.org>  Fri, 31 Jul 2020 16:17:50 +0200

knot-resolver (5.1.2-1) unstable; urgency=low

  * Team upload.
  * New upstream release. (Closes: #966077)
  * preinst, postinst maintainer scripts: base upgrade-4-to-5-related code
    from upstream distro/deb/.
  * Update debian/copyright to include CZ.NIC in debian/ files
  * Document changes and manual action required when upgrading from 3.x, in
    debian/NEWS and through debconf. (Closes: #952673)
    Thanks to Justin B Rye for reviewing the English template.
  * Add Build-Dep on po-debconf
  * Add debian/po

 -- Santiago Ruano Rincón <santiago@debian.org>  Wed, 29 Jul 2020 17:07:51 +0200

knot-resolver (5.1.1-1) unstable; urgency=medium

  * Team upload.
  * Acknowledge 5.1.1-0.1 NMU. Thanks to Daniel Baumann.
  * Mitigates NXNSAttack (CVE-2020-12667) (Closes: #961076)
  * d/tests/control: remove Test-Command: make -k installcheck ... It is
    broken since meson+ninja is used to build kresd
  * d/tests/roundtrip: update to 5.x: change --forks for --noninteractive
    option. fix control socket path
  * Add debian/salsa-ci.yml
  * d/tests/control: set Restrictions: needs-root for roundtrip
  * Add source of dygraph.js to debian/missing-sources
  * update dygraph.min.js in debian/copyright, remove entry for
    dygraph-combined.js
  * remove debian/missing-sources/dygraph-combined.js
  * Renable PIE. Building seems to be OK now.
  * d/control: Bump debhelper-compat to 13

 -- Santiago Ruano Rincón <santiago@debian.org>  Fri, 10 Jul 2020 13:43:19 +0200
